/**
 * Created by GoLand.
 * User: xzghua@gmail.com
 * Date: 2021/7/31
 * Time: 10:18 上午
 */
package main

import (
	"fmt"
	sort2 "sort"
	"strconv"
	"strings"
)

type TreeNode struct {
	Val   int
	Left  *TreeNode
	Right *TreeNode
}

func main() {
	//a := []int{1, 2, 3, 4, 5, 6}
	//fmt.Println(a[:len(a)-1])

	fmt.Println(sort([]int{17, 26}, 7))
	//return
	str := "0,2,1,3,null,5,22,9,4,12,25,null,null,13,14,8,6,null,null,null,null,null,27,24,26,null,17,7,null,28,null,null,null,null,null,19,null,11,10,null,null,null,23,16,15,20,18,null,null,null,null,null,21,null,null,29"
	t := deserialize(str)
	fmt.Println(verticalTraversal(t))
	//[[13,28],[9,24,27,16],[3,8,14,11,19],[2,4,12,7,17,26,15,20,23],[0,5,6,10,21,29],[1,25,18],[22]]
}

func deserialize(data string) *TreeNode {
	if len(data) == 0 {
		return nil
	}

	// 先将字符串按照 逗号 进行切割,分成一个字符串数组
	arr := strings.Split(data, ",")
	// 定义一个 map, key是每层, value是 该层的 队列
	levelMap := make(map[int][]*TreeNode)
	// 初始化层, 当前层从0开始
	var level int
	val, _ := strconv.Atoi(arr[0])
	// 第一层第一个元素就是 根节点, 放到 第一层的队列里
	levelMap[level] = []*TreeNode{{Val: val}}
	// 此时层到1层了
	level++

	// 定一个两个标记位
	// up表示 当前队列遍历的 指针位置(下标)
	// lr 表示 当前遍历到是左节点还是有节点
	// 比如 队列[1,2,3], 当up = 0的时候, 队列的值为1, 然后lr为0,表示当前在 1 的左子节点, 当 lr = 1 表示 当前在1的右子节点
	var up, lr int
	// 遍历所有元素
	for i, v := range arr {
		// 第一个元素就是根节点,已经在上面写了,直接跳过
		if i == 0 {
			continue
		}

		var temp *TreeNode
		// 如果 值为 null, 说明该节点为 nil
		// 否则 该节点的值就是 转成字符串的值
		if v == "null" {
			temp = nil
		} else {
			val, _ = strconv.Atoi(v)
			temp = &TreeNode{Val: val}
			// 把该节点 放到该层的队列里
			levelMap[level] = append(levelMap[level], temp)
		}

		// 该循环 是把这个 节点 赋给上层某个节点,这时候就需要找 应该在哪个节点
		//       1
		//     /  \
		//    2    3
		//   / \  / \
		//  4  5  6  7
		// 比如我们现在是2节点, 看上层现在已经遍历到队列里哪个节点哪个节点了,比如up= 0, lr = 0 说明 2应该放到 1的节点下, 且为它的左节点
		for {
			// 这层如果节点已经遍历到了最后, 那么说明该楼层已经遍历完了,那么就应该跳到下一层,然后 这些数值就恢复到初始化
			if len(levelMap[level-1]) <= up {
				level++
				up = 0
				lr = 0
			}

			// lr 为左节点, 赋值给上一层的左节点,并将 标志位lr改成右节点
			if lr == 0 {
				levelMap[level-1][up].Left = temp
				lr = 1
			} else {
				// lr为右节点, 那么 队列下标可以右移一位, 并把标志位 lr 重置成左节点
				levelMap[level-1][up].Right = temp
				up++
				lr = 0
			}
			break
		}
		// 如果该楼层节点遍历完成,就跳到下一层,并重置标记位
		if len(levelMap[level-1]) <= up {
			level++
			up = 0
			lr = 0
		}

	}
	return levelMap[0][0]
}

func verticalTraversal2(root *TreeNode) (res [][]int) {
	if root == nil {
		return nil
	}

	m := make(map[int][]int)

	var f func(t *TreeNode, n int)

	var min, max int

	f = func(t *TreeNode, n int) {
		if t == nil {
			return
		}
		if n <= min {
			min = n
		}
		if n >= max {
			max = n
		}

		if len(m[n]) == 0 {
			m[n] = append(m[n], t.Val)
		} else {
			m[n] = sort(m[n], t.Val)
		}

		f(t.Left, n-1)
		f(t.Right, n+1)
	}
	f(root, 0)

	for i := min; i <= max; i++ {
		res = append(res, m[i])
	}

	return res
}

func verticalTraversal(root *TreeNode) (res [][]int) {
	if root == nil {
		return nil
	}

	mn := make(map[int]map[int][]int)

	var f func(t *TreeNode, n, deep int)

	var min, max, deepMax int

	f = func(t *TreeNode, n, deep int) {
		if t == nil {
			return
		}
		if n > max {
			max = n
		}

		if n < min {
			min = n
		}
		if deep > deepMax {
			deepMax = deep
		}

		if _, ok := mn[deep]; !ok {
			m := make(map[int][]int)
			m[n] = append(m[n], t.Val)
			mn[deep] = m

		} else {
			mn[deep][n] = append(mn[deep][n], t.Val)

			//if len(mn[deep][n]) == 0 {
			//	mn[deep][n] = append(mn[deep][n], t.Val)
			//
			//} else {
			//	mn[deep][n] = sort(mn[deep][n], t.Val)
			//}
			sort2.Ints(mn[deep][n])

		}

		deep++
		f(t.Left, n-1, deep)
		f(t.Right, n+1, deep)
	}
	f(root, 0, 0)

	//fmt.Println("====================")
	//fmt.Println(min, max, deepMax)

	temp := make(map[int][]int)

	for i := 0; i <= deepMax; i++ {
		for j := min; j <= max; j++ {
			temp[j] = append(temp[j], mn[i][j]...)
		}
	}

	for k, v := range temp {
		fmt.Println(k, v)
	}

	for i := min; i <= max; i++ {
		res = append(res, temp[i])
	}

	return res
}

func sort(arr []int, n int) (res []int) {
	//fmt.Println(arr, n)
	if len(arr) == 1 {
		if arr[0] > n {
			res = []int{n, arr[0]}
		} else {
			res = []int{arr[0], n}
		}
		return
	}

	if n <= arr[0] {
		res = append([]int{n}, arr...)
		return
	}

	if n >= arr[len(arr)-1] {
		res = append(res, n)
	}

	for i := 0; i < len(arr); i++ {
		if n >= arr[i] && n <= arr[i+1] {
			res = append(res, arr[:i+1]...)
			res = append(res, n)
			res = append(res, arr[i+1:]...)
			break
		}
	}
	return
}
